//******************************************************************************
//
// Copyright (c) 2015 Microsoft Corporation. All rights reserved.
//
// This code is licensed under the MIT License (MIT).
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
//******************************************************************************

#import "FoundationsViewController.h"
#import "TaskInfoViewController.h"
#import "URLSessionViewController.h"
#import "UserDefaultsViewController.h"

@interface FoundationsViewController ()

@end

@implementation FoundationsViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    // add foundation test controllers here
    [self addMenuItemViewController:[[TaskInfoViewController alloc] init] andTitle:@"task_info"];

    [self addMenuItemViewController:[[URLSessionViewController alloc] init] andTitle:@"URL Session"];

    [self addMenuItemViewController:[[UserDefaultsViewController alloc] init] andTitle:@"UserDefaults"];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
